<?php

namespace Teknisa\FIN\Controllers;


use Teknisa\FIN\Controllers\TeknisaCrud;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;

class EmpresaCnab extends TeknisaCrud{
  protected $dataSourceName = 'empresa_cnab';
  protected $parameterBagColumns = array ("P_CDBANCO");
  protected $Ger08300BancoService;

  public function __construct($crudService,$parameterBag,$Ger08300BancoService) {
    parent::__construct($crudService, $parameterBag);
    $this->Ger08300BancoService = $Ger08300BancoService;
  }
  public function save(DTO\Request $request, DTO\Response $response) {
    $rows = $request->getRow();
    $condition = array(
      array(
        "value" => $rows["CDBANCO"],
        "operator" => "=",
        "columnName" => "CDBANCO"
        ),
      array(
        "value" => $rows["CDEMPRESA"],
        "operator" => "=",
        "columnName" => "CDEMPRESA"
        )
      );

    $dataSourceName = 'emprbanc';
    $resul = $this->realizaConsultaBanco($condition, $dataSourceName);
    $rows=$resul->getRows();
    if(empty($rows)){
      $row = $request->getRow();
      $row['__is_new'] =  true;
      parent::save($request, $response);
    } else {
      $row = $request->getRow();
      $this->Ger08300BancoService->saveCNABdata($row);
    }
  }
  public function realizaConsultaBanco($conditions, $dataSourceName) {
    if (!isset($dataSourceName)){
      $this->dataSourceName;
    }
    $filterCriteria = new FilterCriteria($dataSourceName,$conditions);
    $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
    $dataSet = $this->Ger08300BancoService->buscar($newFilterCriteria);
    return $dataSet;
  }

}