<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Controllers;

use Teknisa\FIN\Modules\MovimentacaoBancaria\Services\Bco00500RecalculoOrcamentoFluxoCaixaService;
use Teknisa\FIN\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Exception;


class Bco00500RecalculoOrcamentoFluxoCaixaController extends TeknisaCrud {

    protected $dataSourceName, $masks, $service;

    public function __construct($crudService, $parameterBag, Bco00500RecalculoOrcamentoFluxoCaixaService $bco00500RecalculoOrcamentoFluxoCaixaService) {
        $this->bco00500RecalculoOrcamentoFluxoCaixaService = $bco00500RecalculoOrcamentoFluxoCaixaService;
        //parent::__construct($crudService, $parameterBag);
    }

    public function recalcularOrcamentoFluxoCaixa(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $data = $request->getDataSet()->getRows();
            $row = $data[0];
            $classificacoesFinanceiras = $data[1];
            $this->bco00500RecalculoOrcamentoFluxoCaixaService->recalcularOrcamentoFluxoCaixa($classificacoesFinanceiras, $row);
        } catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }

    public function saveOrcamentoFluxoCaixa(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $data = $request->getDataSet()->getRows();
            $row = $data[0];
            $orcamentos = $data[1];
            $this->bco00500RecalculoOrcamentoFluxoCaixaService->saveOrcamentoFluxoCaixa($orcamentos, $row);
        } catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }

    public function cadastramentoAutomatico(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $data = $request->getDataSet()->getRows();
            $opcao = $data[0];
            $origem = $data[1];
            $destino = $data[2];
            $this->bco00500RecalculoOrcamentoFluxoCaixaService->CadastramentoAutomaticoDoOrcamento($opcao, $origem, $destino);
        } catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
}
